<template>
  <div class="products">
    <the-header title="Produtos" subtitle="Produtos adicionados ao sistema" />
    <the-table 
      :isLoading="isLoading"
      title="Itens adicionados" 
      perPage="20"
      :content="products" 
      :columns="columns"
      v-on:createItem="createItem"
      v-on:readItem="readItem"
      v-on:updateItem="updateItem"
      v-on:deleteItem="deleteItem">
    </the-table>
  </div>
</template>

<script>
export default {
  name: 'IndexProducts',
  data: function ()  {
    return {}
  },
  created () {
    this.$store.dispatch('getProducts')
  },
  methods: {
    createItem: function () {
    },
    readItem: function (obj) {
      this.$router.push({ name: 'read-products', params: { pk: obj.id } })
    },
    updateItem: function (obj) {
      this.$router.push({ name: 'update-products', params: { pk: obj.id } })
    },
    deleteItem: function (obj) {
      console.log(this.$cookies.get('csrftoken'))
      obj.csrftoken = this.$cookies.get('csrftoken')
      this.$store.dispatch('deleteProduct', obj)
      this.$store.dispatch('getProducts')
    }
  },
  computed: {
    products () {
      return this.$store.state.products.products
    },
    columns () {
      return [
        {
          field: 'id',
          label: 'ID',
          numeric: true
        },
        {
          field: 'description',
          label: 'Descrição'
        },
        {
          field: 'price',
          label: 'Preço',
          numeric: true,
          sortable: true
        },
        {
          field: 'created_at',
          label: 'Criado em'
        },
        {
          field: 'updated_at',
          label: 'Atualizado em'
        }
      ]
      
    },
    isLoading () {
      return this.$store.state.products.loading
    },
    error () {
      return this.$store.state.products.error
    },
    errorMsg () {
      return this.$store.state.products.errorMsg
    }
  }
}
</script>
